## ros-rolling-rclcpp-lifecycle 15.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclcpp_lifecycle)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rosidl_typesupport_cpp REQUIRED)
find_package(lifecycle_msgs REQUIRED)

### CPP High level library
add_library(rclcpp_lifecycle
  src/lifecycle_node.cpp
  src/managed_entity.cpp
  src/node_interfaces/lifecycle_node_interface.cpp
  src/state.cpp
  src/transition.cpp
)
target_include_directories(${PROJECT_NAME}
  PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
# specific order: dependents before dependencies
ament_target_dependencies(rclcpp_lifecycle
  "rclcpp"
  "rcl_lifecycle"
  "lifecycle_msgs"
  "rosidl_typesupport_cpp"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rclcpp_lifecycle PRIVATE "RCLCPP_LIFECYCLE_BUILDING_DLL")

install(TARGETS
  rclcpp_lifecycle EXPORT rclcpp_lifecycle
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  set(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS ${rclcpp_INCLUDE_DIRS})
  ament_lint_auto_find_test_dependencies()

  find_package(performance_test_fixture REQUIRED)

  add_performance_test(
    benchmark_lifecycle_client
    test/benchmark/benchmark_lifecycle_client.cpp)
  if(TARGET benchmark_lifecycle_client)
    target_link_libraries(benchmark_lifecycle_client ${PROJECT_NAME})
    ament_target_dependencies(benchmark_lifecycle_client rclcpp)
  endif()
  add_performance_test(
    benchmark_lifecycle_node
    test/benchmark/benchmark_lifecycle_node.cpp)
  if(TARGET benchmark_lifecycle_node)
    target_link_libraries(benchmark_lifecycle_node ${PROJECT_NAME})
    ament_target_dependencies(benchmark_lifecycle_node rclcpp)
  endif()
  add_performance_test(
    benchmark_state
    test/benchmark/benchmark_state.cpp)
  if(TARGET benchmark_state)
    target_link_libraries(benchmark_state ${PROJECT_NAME})
  endif()
  add_performance_test(
    benchmark_transition
    test/benchmark/benchmark_transition.cpp)
  if(TARGET benchmark_transition)
    target_link_libraries(benchmark_transition ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_lifecycle_node test/test_lifecycle_node.cpp TIMEOUT 120)
  if(TARGET test_lifecycle_node)
    ament_target_dependencies(test_lifecycle_node
      "rcl_lifecycle"
      "rclcpp"
      "rcutils"
    )
    target_link_libraries(test_lifecycle_node ${PROJECT_NAME} mimick)
  endif()
  ament_add_gtest(test_lifecycle_publisher test/test_lifecycle_publisher.cpp)
  if(TARGET test_lifecycle_publisher)
    ament_target_dependencies(test_lifecycle_publisher
      "rcl_lifecycle"
      "rclcpp"
      "test_msgs"
    )
    target_link_libraries(test_lifecycle_publisher ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_lifecycle_service_client test/test_lifecycle_service_client.cpp TIMEOUT 120)
  if(TARGET test_lifecycle_service_client)
    ament_target_dependencies(test_lifecycle_service_client
      "rcl_lifecycle"
      "rclcpp"
      "rcpputils"
      "rcutils"
    )
    target_link_libraries(test_lifecycle_service_client ${PROJECT_NAME} mimick)
  endif()
  ament_add_gtest(test_state_machine_info test/test_state_machine_info.cpp)
  if(TARGET test_state_machine_info)
    ament_target_dependencies(test_state_machine_info
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_state_machine_info ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_register_custom_callbacks test/test_register_custom_callbacks.cpp)
  if(TARGET test_register_custom_callbacks)
    ament_target_dependencies(test_register_custom_callbacks
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_register_custom_callbacks ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_callback_exceptions test/test_callback_exceptions.cpp)
  if(TARGET test_callback_exceptions)
    ament_target_dependencies(test_callback_exceptions
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_callback_exceptions ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_state_wrapper test/test_state_wrapper.cpp)
  if(TARGET test_state_wrapper)
    ament_target_dependencies(test_state_wrapper
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_state_wrapper ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_transition_wrapper test/test_transition_wrapper.cpp)
  if(TARGET test_transition_wrapper)
    ament_target_dependencies(test_transition_wrapper
      "rcl_lifecycle"
      "rclcpp"
      "rcutils"
    )
    target_link_libraries(test_transition_wrapper ${PROJECT_NAME} mimick)
    target_compile_definitions(test_transition_wrapper
      PUBLIC RCUTILS_ENABLE_FAULT_INJECTION
    )
  endif()
endif()

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})
ament_export_dependencies(rclcpp)
ament_export_dependencies(rcl_lifecycle)
ament_export_dependencies(lifecycle_msgs)
ament_package()

install(DIRECTORY include/
  DESTINATION include)

=== debian/changelog ===
ros-rolling-rclcpp-lifecycle (15.0.0-1focal) focal; urgency=high

  * Automatically transition lifecycle entities when node transitions (#1863 <https://github.com/ros2/rclcpp/issues/1863>)
  * Contributors: Ivan Santiago Paunovic

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 14 Jan 2022 08:00:00 -0000

ros-rolling-rclcpp-lifecycle (14.1.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 05 Jan 2022 08:00:00 -0000

ros-rolling-rclcpp-lifecycle (14.0.0-1focal) focal; urgency=high

  * Remove author by request (#1818 <https://github.com/ros2/rclcpp/issues/1818>)
  * Update maintainers (#1817 <https://github.com/ros2/rclcpp/issues/1817>)
  * Suppress clang dead-store warnings in the benchmarks. (#1802 <https://github.com/ros2/rclcpp/issues/1802>)
  * Contributors: Chris Lalancette, Jacob Perron

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 17 Dec 2021 08:00:00 -0000

ros-rolling-rclcpp-lifecycle (13.1.0-1focal) focal; urgency=high

  * Update forward declarations of rcl_lifecycle types (#1788 <https://github.com/ros2/rclcpp/issues/1788>)
  * Deprecate the void shared_ptr<MessageT> subscription callback signatures (#1713 <https://github.com/ros2/rclcpp/issues/1713>)
  * Contributors: Abrar Rahman Protyasha, Michel Hidalgo

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 18 Oct 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (13.0.0-1focal) focal; urgency=high

  * Update client API to be able to remove pending requests. (#1734 <https://github.com/ros2/rclcpp/issues/1734>)
  * Change log level for lifecycle_publisher. (#1715 <https://github.com/ros2/rclcpp/issues/1715>)
  * Fix: RCLCPP_PUBLIC -> RCLCPP_LIFECYCLE_PUBLIC (#1732 <https://github.com/ros2/rclcpp/issues/1732>)
  * Use rcpputils/scope_exit.hpp and remove rclcpp/scope_exit.hpp (#1727 <https://github.com/ros2/rclcpp/issues/1727>)
  * Contributors: Alberto Soragna, Christophe Bedard, Ivan Santiago Paunovic, Shane Loretz

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 23 Aug 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (12.0.0-1focal) focal; urgency=high

  * Remove unsafe get_callback_groups API.
    Callers should change to using for_each_callback_group(), or
    store the callback groups they need internally.
  * Add in callback_groups_for_each.
    The main reason to add this method in is to make accesses to the
    callback_groups_ vector thread-safe.  By having a
    callback_groups_for_each that accepts a std::function, we can
    just have the callers give us the callback they are interested
    in, and we can take care of the locking.
    The rest of this fairly large PR is cleaning up all of the places
    that use get_callback_groups() to instead use
    callback_groups_for_each().
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 26 Jul 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (11.2.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 21 Jul 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (11.1.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 13 Jul 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (11.0.0-1focal) focal; urgency=high

  * Fix destruction order in lifecycle benchmark (#1675 <https://github.com/ros2/rclcpp/issues/1675>)
  * Contributors: Scott K Logan

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 18 May 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (10.0.0-1focal) focal; urgency=high

  * [rclcpp] Type Adaptation feature (#1557 <https://github.com/ros2/rclcpp/issues/1557>)
  * Contributors: Audrow Nash, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 11 May 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (9.0.2-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 14 Apr 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (9.0.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Apr 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (9.0.0-1focal) focal; urgency=high

  * Add generic publisher and generic subscription for serialized messages (#1452 <https://github.com/ros2/rclcpp/issues/1452>)
  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#1615 <https://github.com/ros2/rclcpp/issues/1615>)
  * Contributors: Nikolai Morin, shonigmann

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Apr 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (8.2.0-1focal) focal; urgency=high

  * Fix flaky lifecycle node tests (#1606 <https://github.com/ros2/rclcpp/issues/1606>)
  * Clock subscription callback group spins in its own thread (#1556 <https://github.com/ros2/rclcpp/issues/1556>)
  * Delete debug messages (#1602 <https://github.com/ros2/rclcpp/issues/1602>)
  * add automatically_add_executor_with_node option (#1594 <https://github.com/ros2/rclcpp/issues/1594>)
  * Contributors: BriceRenaudeau, Ivan Santiago Paunovic, Jacob Perron, anaelle-sw

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 31 Mar 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (8.1.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 25 Mar 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (8.0.0-1focal) focal; urgency=high

  * make rcl_lifecyle_com_interface optional in lifecycle nodes (#1507 <https://github.com/ros2/rclcpp/issues/1507>)
  * Contributors: Karsten Knese

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Mar 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (7.0.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 22 Mar 2021 07:00:00 -0000

ros-rolling-rclcpp-lifecycle (7.0.0-1focal) focal; urgency=high

  * Add support for rmw_connextdds (#1574 <https://github.com/ros2/rclcpp/issues/1574>)
  * Fix SEGV caused by order of destruction of Node sub-interfaces (#1469 <https://github.com/ros2/rclcpp/issues/1469>)


=== debian/control ===
Source: ros-rolling-rclcpp-lifecycle
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-gtest, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-lifecycle-msgs, ros-rolling-mimick-vendor, ros-rolling-performance-test-fixture, ros-rolling-rcl-lifecycle, ros-rolling-rclcpp, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rosidl-typesupport-cpp, ros-rolling-test-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rclcpp-lifecycle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-lifecycle-msgs, ros-rolling-rcl-lifecycle, ros-rolling-rclcpp, ros-rolling-rmw, ros-rolling-rosidl-typesupport-cpp, ros-rolling-ros-workspace
Description: Package containing a prototype for lifecycle implementation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rclcpp-lifecycle//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rclcpp-lifecycle 23.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclcpp_lifecycle)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(rcl REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_typesupport_cpp REQUIRED)

### CPP High level library
add_library(rclcpp_lifecycle
  src/lifecycle_node.cpp
  src/lifecycle_node_interface_impl.cpp
  src/managed_entity.cpp
  src/node_interfaces/lifecycle_node_interface.cpp
  src/state.cpp
  src/transition.cpp
)
target_include_directories(${PROJECT_NAME}
  PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
target_link_libraries(${PROJECT_NAME}
  ${lifecycle_msgs_TARGETS}
  rcl::rcl
  rclcpp::rclcpp
  ${rcl_interfaces_TARGETS}
  rcl_lifecycle::rcl_lifecycle
  rcutils::rcutils
  rosidl_typesupport_cpp::rosidl_typesupport_cpp
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rclcpp_lifecycle PRIVATE "RCLCPP_LIFECYCLE_BUILDING_DLL")

install(TARGETS
  rclcpp_lifecycle EXPORT rclcpp_lifecycle
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(DIRECTORY include/
  DESTINATION include/${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  set(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS ${rclcpp_INCLUDE_DIRS})
  ament_lint_auto_find_test_dependencies()

  find_package(performance_test_fixture REQUIRED)

  add_performance_test(
    benchmark_lifecycle_client
    test/benchmark/benchmark_lifecycle_client.cpp)
  if(TARGET benchmark_lifecycle_client)
    target_link_libraries(benchmark_lifecycle_client ${PROJECT_NAME} rclcpp::rclcpp)
  endif()
  add_performance_test(
    benchmark_lifecycle_node
    test/benchmark/benchmark_lifecycle_node.cpp)
  if(TARGET benchmark_lifecycle_node)
    target_link_libraries(benchmark_lifecycle_node ${PROJECT_NAME} rclcpp::rclcpp)
  endif()
  add_performance_test(
    benchmark_state
    test/benchmark/benchmark_state.cpp)
  if(TARGET benchmark_state)
    target_link_libraries(benchmark_state ${PROJECT_NAME})
  endif()
  add_performance_test(
    benchmark_transition
    test/benchmark/benchmark_transition.cpp)
  if(TARGET benchmark_transition)
    target_link_libraries(benchmark_transition ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_lifecycle_node test/test_lifecycle_node.cpp TIMEOUT 120)
  if(TARGET test_lifecycle_node)
    target_link_libraries(test_lifecycle_node ${PROJECT_NAME} mimick rcl_lifecycle::rcl_lifecycle rclcpp::rclcpp rcutils::rcutils)
  endif()
  ament_add_gtest(test_lifecycle_publisher test/test_lifecycle_publisher.cpp)
  if(TARGET test_lifecycle_publisher)
    target_link_libraries(test_lifecycle_publisher ${PROJECT_NAME} rcl_lifecycle::rcl_lifecycle rclcpp::rclcpp ${test_msgs_TARGETS})
  endif()
  ament_add_gtest(test_lifecycle_service_client test/test_lifecycle_service_client.cpp TIMEOUT 120)
  if(TARGET test_lifecycle_service_client)
    target_link_libraries(test_lifecycle_service_client
      ${PROJECT_NAME}
      mimick
      rcl_lifecycle::rcl_lifecycle
      rclcpp::rclcpp
      rcpputils::rcpputils
      rcutils::rcutils)
  endif()
  ament_add_gtest(test_client test/test_client.cpp TIMEOUT 120)
  if(TARGET test_client)
    target_link_libraries(test_client
      ${PROJECT_NAME}
      mimick
      ${rcl_interfaces_TARGETS}
      rclcpp::rclcpp)
  endif()
  ament_add_gtest(test_service test/test_service.cpp TIMEOUT 120)
  if(TARGET test_service)
    target_link_libraries(test_service
      ${PROJECT_NAME}
      mimick
      ${test_msgs_TARGETS}
      rclcpp::rclcpp)
  endif()
  ament_add_gtest(test_state_machine_info test/test_state_machine_info.cpp)
  if(TARGET test_state_machine_info)
    target_link_libraries(test_state_machine_info ${PROJECT_NAME} rcl_lifecycle::rcl_lifecycle rclcpp::rclcpp)
  endif()
  ament_add_gtest(test_register_custom_callbacks test/test_register_custom_callbacks.cpp)
  if(TARGET test_register_custom_callbacks)
    target_link_libraries(test_register_custom_callbacks ${PROJECT_NAME} rcl_lifecycle::rcl_lifecycle rclcpp::rclcpp)
  endif()
  ament_add_gtest(test_callback_exceptions test/test_callback_exceptions.cpp)
  if(TARGET test_callback_exceptions)
    target_link_libraries(test_callback_exceptions ${PROJECT_NAME} rcl_lifecycle::rcl_lifecycle rclcpp::rclcpp)
  endif()
  ament_add_gtest(test_state_wrapper test/test_state_wrapper.cpp)
  if(TARGET test_state_wrapper)
    target_link_libraries(test_state_wrapper ${PROJECT_NAME} rcl_lifecycle::rcl_lifecycle rclcpp::rclcpp)
  endif()
  ament_add_gtest(test_transition_wrapper test/test_transition_wrapper.cpp)
  if(TARGET test_transition_wrapper)
    target_link_libraries(test_transition_wrapper ${PROJECT_NAME} mimick rcl_lifecycle::rcl_lifecycle rclcpp::rclcpp rcutils::rcutils)
    target_compile_definitions(test_transition_wrapper
      PUBLIC RCUTILS_ENABLE_FAULT_INJECTION
    )
  endif()
endif()

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

# Export dependencies
ament_export_dependencies(lifecycle_msgs rcl rclcpp rcl_interfaces rcl_lifecycle rcutils rosidl_typesupport_cpp)

ament_package()

=== debian/changelog ===
ros-rolling-rclcpp-lifecycle (23.0.0-1jammy) jammy; urgency=high

  * Update API docs links in package READMEs (#2302 <https://github.com/ros2/rclcpp/issues/2302>)
  * Contributors: Christophe Bedard

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 Sep 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (22.2.0-1jammy) jammy; urgency=high

  * add logger level service to lifecycle node. (#2277 <https://github.com/ros2/rclcpp/issues/2277>)
  * Contributors: Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 07 Sep 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (22.1.0-1jammy) jammy; urgency=high

  * Stop using constref signature of benchmark DoNotOptimize. (#2238 <https://github.com/ros2/rclcpp/issues/2238>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 21 Aug 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (22.0.0-1jammy) jammy; urgency=high

  * Implement get_node_type_descriptions_interface for lifecyclenode and add smoke test for it (#2237 <https://github.com/ros2/rclcpp/issues/2237>)
  * Switch lifecycle to use the RCLCPP macros. (#2233 <https://github.com/ros2/rclcpp/issues/2233>)
  * Add new node interface TypeDescriptionsInterface to provide GetTypeDescription service (#2224 <https://github.com/ros2/rclcpp/issues/2224>)
  * Contributors: Chris Lalancette, Emerson Knapp

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 11 Jul 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (21.3.0-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Jun 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (21.2.0-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 07 Jun 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (21.1.1-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 11 May 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (21.1.0-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 27 Apr 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (21.0.0-1jammy) jammy; urgency=high

  * Add support for logging service. (#2122 <https://github.com/ros2/rclcpp/issues/2122>)
  * Support publishing loaned messages in LifecyclePublisher (#2159 <https://github.com/ros2/rclcpp/issues/2159>)
  * Contributors: Lei Liu, Michael Babenko

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 18 Apr 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (20.0.0-1jammy) jammy; urgency=high

  * Fixes to silence some clang warnings. (#2127 <https://github.com/ros2/rclcpp/issues/2127>)
  * Update all rclcpp packages to C++17. (#2121 <https://github.com/ros2/rclcpp/issues/2121>)
  * Use the correct macro for LifecycleNode::get_fully_qualified_name (#2117 <https://github.com/ros2/rclcpp/issues/2117>)
  * add get_fully_qualified_name to rclcpp_lifecycle (#2115 <https://github.com/ros2/rclcpp/issues/2115>)
  * Contributors: Chris Lalancette, Steve Macenski

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 13 Apr 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (19.3.0-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 01 Mar 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (19.2.0-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 24 Feb 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (19.1.0-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 14 Feb 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (19.0.0-1jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 30 Jan 2023 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (18.0.0-1jammy) jammy; urgency=high

  * Implement Unified Node Interface (NodeInterfaces class) (#2041 <https://github.com/ros2/rclcpp/issues/2041>)
  * Add clock type to node_options (#1982 <https://github.com/ros2/rclcpp/issues/1982>)
  * Update maintainers (#2043 <https://github.com/ros2/rclcpp/issues/2043>)
  * Contributors: Audrow Nash, Jeffery Hsu, methylDragon

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 29 Dec 2022 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (17.1.0-1jammy) jammy; urgency=high

  * LifecycleNode on_configure doc fix. (#2034 <https://github.com/ros2/rclcpp/issues/2034>)
  * Bugfix 20210810 get current state (#1756 <https://github.com/ros2/rclcpp/issues/1756>)
  * Make lifecycle impl get_current_state() const. (#2031 <https://github.com/ros2/rclcpp/issues/2031>)
  * Cleanup the lifecycle implementation (#2027 <https://github.com/ros2/rclcpp/issues/2027>)
  * Cleanup the rclcpp_lifecycle dependencies. (#2021 <https://github.com/ros2/rclcpp/issues/2021>)
  * Contributors: Chris Lalancette, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 02 Nov 2022 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (17.0.0-1jammy) jammy; urgency=high

  * Revert "Revert "Add a create_timer method to Node and LifecycleNode classes (#1975 <https://github.com/ros2/rclcpp/issues/1975>)" (#2009 <https://github.com/ros2/rclcpp/issues/2009>) (#2010 <https://github.com/ros2/rclcpp/issues/2010>)
  * Revert "Add a create_timer method to Node and LifecycleNode classes (#1975 <https://github.com/ros2/rclcpp/issues/1975>)" (#2009 <https://github.com/ros2/rclcpp/issues/2009>)
  * Add a create_timer method to Node and LifecycleNode classes (#1975 <https://github.com/ros2/rclcpp/issues/1975>)
  * Support pre-set and post-set parameter callbacks in addition to on-set-parameter-callback. (#1947 <https://github.com/ros2/rclcpp/issues/1947>)
  * Make create_service accept rclcpp::QoS (#1969 <https://github.com/ros2/rclcpp/issues/1969>)
  * Make create_client accept rclcpp::QoS (#1964 <https://github.com/ros2/rclcpp/issues/1964>)
  * Contributors: Andrew Symington, Deepanshu Bansal, Ivan Santiago Paunovic, Shane Loretz

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 13 Sep 2022 00:00:00 -0000

ros-rolling-rclcpp-lifecycle (16.2.0-1jammy) jammy; urgency=high





=== debian/control ===
Source: ros-rolling-rclcpp-lifecycle
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-lifecycle-msgs, ros-rolling-mimick-vendor <!nocheck>, ros-rolling-performance-test-fixture <!nocheck>, ros-rolling-rcl, ros-rolling-rcl-interfaces, ros-rolling-rcl-lifecycle, ros-rolling-rclcpp, ros-rolling-rcpputils <!nocheck>, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rosidl-typesupport-cpp, ros-rolling-test-msgs <!nocheck>, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rclcpp-lifecycle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-lifecycle-msgs, ros-rolling-rcl, ros-rolling-rcl-interfaces, ros-rolling-rcl-lifecycle, ros-rolling-rclcpp, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rosidl-typesupport-cpp, ros-rolling-ros-workspace
Description: Package containing a prototype for lifecycle implementation

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
